git-merge: document the -S option
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
c2116a17
JH
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
3c8f12c9
JH
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29fi
30if test -z "$TEST_OUTPUT_DIRECTORY"
31then
32 # Similarly, override this to store the test-results subdir
33 # elsewhere
34 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
35fi
36GIT_BUILD_DIR="$TEST_DIRECTORY"/..
37
2006f0ad
RR
38################################################################
39# It appears that people try to run tests without building...
40"$GIT_BUILD_DIR/git" >/dev/null
41if test $? != 1
42then
43 echo >&2 'error: you do not seem to have built git yet.'
44 exit 1
45fi
46
3c8f12c9
JH
47. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48export PERL_PATH SHELL_PATH
49
4cde519f
RR
50# if --tee was passed, write the output not only to the terminal, but
51# additionally to the file test-results/$BASENAME.out, too.
52case "$GIT_TEST_TEE_STARTED, $* " in
53done,*)
54 # do not redirect again
55 ;;
56*' --tee '*|*' --va'*)
2d14e13c
JK
57 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
58 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
4cde519f
RR
59 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $? > $BASE.exit) | tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
62 exit
63 ;;
64esac
65
e1970ce4
JH
66# For repeatability, reset the environment to known value.
67LANG=C
899460f3 68LC_ALL=C
d9bdd39e 69PAGER=cat
e1970ce4 70TZ=UTC
c2116a17
JH
71TERM=dumb
72export LANG LC_ALL PAGER TERM TZ
8ff99e74 73EDITOR=:
661bfd13
SL
74# A call to "unset" with no arguments causes at least Solaris 10
75# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76# deriving from the command substitution clustered with the other
77# ones.
3c8f12c9 78unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 79 my @env = keys %ENV;
730477f1
JL
80 my $ok = join("|", qw(
81 TRACE
82 DEBUG
83 USE_LOOKUP
84 TEST
85 .*_TEST
86 PROVE
87 VALGRIND
ac001282 88 UNZIP
edb54081 89 PERF_
730477f1
JL
90 ));
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
92 print join("\n", @vars);
93')
5adf84eb 94unset XDG_CONFIG_HOME
8bade1e1 95unset GITPERLLIB
29e55cd5
JH
96GIT_AUTHOR_EMAIL=author@example.com
97GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
98GIT_COMMITTER_EMAIL=committer@example.com
99GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 100GIT_MERGE_VERBOSITY=5
f8246281
JH
101GIT_MERGE_AUTOEDIT=no
102export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
103export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
104export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 105export EDITOR
e1970ce4 106
a731fa91
EP
107# Add libc MALLOC and MALLOC_PERTURB test
108# only if we are not executing the test with valgrind
1b3185fc 109if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 110 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
111then
112 setup_malloc_check () {
113 : nothing
114 }
115 teardown_malloc_check () {
116 : nothing
117 }
118else
119 setup_malloc_check () {
120 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
121 export MALLOC_CHECK_ MALLOC_PERTURB_
122 }
123 teardown_malloc_check () {
124 unset MALLOC_CHECK_ MALLOC_PERTURB_
125 }
126fi
a731fa91 127
886a3907
JH
128# Protect ourselves from common misconfiguration to export
129# CDPATH into the environment
130unset CDPATH
131
5565f47c 132unset GREP_OPTIONS
ac001282 133unset UNZIP
5565f47c 134
3d5c0cc9 135case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756
RJ
1361|2|true)
137 echo "* warning: Some tests will not work if GIT_TRACE" \
138 "is set as to trace on STDERR ! *"
139 echo "* warning: Please set GIT_TRACE to something" \
140 "other than 1, 2 or true ! *"
141 ;;
6ce4e61f
CC
142esac
143
cd3c095c
JH
144# Convenience
145#
146# A regexp to match 5 and 40 hexdigits
147_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
148_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
149
3749fde5
JH
150# Zero SHA-1
151_z40=0000000000000000000000000000000000000000
152
3f4ab627
JH
153# Line feed
154LF='
155'
156
342e9ef2
TR
157export _x05 _x40 _z40 LF
158
e1970ce4
JH
159# Each test should start with something like this, after copyright notices:
160#
161# test_description='Description of this test...
162# This test checks if command xyzzy does the right thing...
163# '
164# . ./test-lib.sh
c2116a17
JH
165[ "x$ORIGINAL_TERM" != "xdumb" ] && (
166 TERM=$ORIGINAL_TERM &&
167 export TERM &&
168 [ -t 1 ] &&
169 tput bold >/dev/null 2>&1 &&
170 tput setaf 1 >/dev/null 2>&1 &&
171 tput sgr0 >/dev/null 2>&1
172 ) &&
55db1df0 173 color=t
e1970ce4 174
e1970ce4
JH
175while test "$#" -ne 0
176do
177 case "$1" in
178 -d|--d|--de|--deb|--debu|--debug)
179 debug=t; shift ;;
886856ab
JH
180 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
181 immediate=t; shift ;;
5e2c08c6 182 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 183 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 184 -h|--h|--he|--hel|--help)
570f3226 185 help=t; shift ;;
e1970ce4
JH
186 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
187 verbose=t; shift ;;
ff09af3f
TR
188 --verbose-only=*)
189 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
190 shift ;;
1ece1274 191 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
192 # Ignore --quiet under a TAP::Harness. Saying how many tests
193 # passed without the ok/not ok details is always an error.
194 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
195 --with-dashes)
196 with_dashes=t; shift ;;
55db1df0 197 --no-color)
faa4bc35 198 color=; shift ;;
4e1be63c 199 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
200 valgrind=memcheck
201 shift ;;
202 --valgrind=*)
203 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
204 shift ;;
5dfc368f
TR
205 --valgrind-only=*)
206 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
207 shift ;;
ad0e6233
TR
208 --valgrind-parallel=*)
209 valgrind_parallel=$(expr "z$1" : 'z[^=]*=\(.*\)')
210 shift ;;
211 --valgrind-only-stride=*)
212 valgrind_only_stride=$(expr "z$1" : 'z[^=]*=\(.*\)')
213 shift ;;
214 --valgrind-only-offset=*)
215 valgrind_only_offset=$(expr "z$1" : 'z[^=]*=\(.*\)')
216 shift ;;
44138559
JS
217 --tee)
218 shift ;; # was handled already
f423ef5f
JK
219 --root=*)
220 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
221 shift ;;
e939e15d
TR
222 --statusprefix=*)
223 statusprefix=$(expr "z$1" : 'z[^=]*=\(.*\)')
224 shift ;;
e1970ce4 225 *)
1f729dca 226 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
227 esac
228done
229
ad0e6233 230if test -n "$valgrind_only" || test -n "$valgrind_only_stride"
5dfc368f
TR
231then
232 test -z "$valgrind" && valgrind=memcheck
233 test -z "$verbose" && verbose_only="$valgrind_only"
234elif test -n "$valgrind"
235then
236 verbose=t
237fi
952af351 238
1c0cc756
RJ
239if test -n "$color"
240then
55db1df0 241 say_color () {
c2116a17
JH
242 (
243 TERM=$ORIGINAL_TERM
244 export TERM
55db1df0 245 case "$1" in
1c0cc756
RJ
246 error)
247 tput bold; tput setaf 1;; # bold red
248 skip)
b8fc855a 249 tput setaf 4;; # blue
e8e51955
AS
250 warn)
251 tput setaf 3;; # brown/yellow
1c0cc756 252 pass)
0a6d4751 253 tput setaf 2;; # green
1c0cc756 254 info)
0a6d4751 255 tput setaf 6;; # cyan
1c0cc756
RJ
256 *)
257 test -n "$quiet" && return;;
55db1df0
PH
258 esac
259 shift
5099b99d 260 printf "%s" "$*"
55db1df0 261 tput sgr0
b8eecafd 262 echo
c2116a17 263 )
55db1df0
PH
264 }
265else
266 say_color() {
1ece1274 267 test -z "$1" && test -n "$quiet" && return
55db1df0 268 shift
7bc0911d 269 printf "%s\n" "$*"
55db1df0
PH
270 }
271fi
272
273error () {
274 say_color error "error: $*"
6e7b5aaf 275 GIT_EXIT_OK=t
55db1df0
PH
276 exit 1
277}
278
279say () {
280 say_color info "$*"
281}
282
570f3226
MB
283test "${test_description}" != "" ||
284error "Test script did not set test_description."
285
286if test "$help" = "t"
287then
288 echo "$test_description"
289 exit 0
290fi
291
4d9d62fa 292exec 5>&1
781f76b1 293exec 6<&0
e1970ce4
JH
294if test "$verbose" = "t"
295then
296 exec 4>&2 3>&1
297else
298 exec 4>/dev/null 3>/dev/null
299fi
300
301test_failure=0
302test_count=0
41ac414e
JH
303test_fixed=0
304test_broken=0
2d84e9fb 305test_success=0
e1970ce4 306
d998bd4a
ÆAB
307test_external_has_tap=0
308
faa4bc35 309die () {
6e7b5aaf
CB
310 code=$?
311 if test -n "$GIT_EXIT_OK"
312 then
313 exit $code
314 else
315 echo >&5 "FATAL: Unexpected exit with code $code"
316 exit 1
317 fi
faa4bc35
CB
318}
319
6e7b5aaf 320GIT_EXIT_OK=
35641310 321trap 'die' EXIT
41184273 322
12a29b1a
TR
323# The user-facing functions are loaded from a separate file so that
324# test_perf subshells can have them too
3c8f12c9 325. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 326
886856ab
JH
327# You are not expected to call test_ok_ and test_failure_ directly, use
328# the text_expect_* functions instead.
329
330test_ok_ () {
d5d9de1b 331 test_success=$(($test_success + 1))
e939e15d 332 say_color "" "${statusprefix}ok $test_count - $@"
e1970ce4
JH
333}
334
886856ab 335test_failure_ () {
d5d9de1b 336 test_failure=$(($test_failure + 1))
e939e15d 337 say_color error "${statusprefix}not ok $test_count - $1"
bf0dd8a8 338 shift
5099b99d 339 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 340 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
341}
342
41ac414e 343test_known_broken_ok_ () {
41ac414e 344 test_fixed=$(($test_fixed+1))
e939e15d 345 say_color error "${statusprefix}ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
346}
347
348test_known_broken_failure_ () {
41ac414e 349 test_broken=$(($test_broken+1))
e939e15d 350 say_color warn "${statusprefix}not ok $test_count - $@ # TODO known breakage"
41ac414e 351}
886856ab
JH
352
353test_debug () {
8e832ebc 354 test "$debug" = "" || eval "$1"
e1970ce4
JH
355}
356
e6a6ddc9
TR
357match_pattern_list () {
358 arg="$1"
359 shift
360 test -z "$*" && return 1
361 for pattern_
362 do
363 case "$arg" in
364 $pattern_)
365 return 0
366 esac
367 done
368 return 1
369}
370
ff09af3f
TR
371maybe_teardown_verbose () {
372 test -z "$verbose_only" && return
373 exec 4>/dev/null 3>/dev/null
374 verbose=
375}
376
377last_verbose=t
378maybe_setup_verbose () {
379 test -z "$verbose_only" && return
ad0e6233
TR
380 if match_pattern_list $test_count $verbose_only ||
381 { test -n "$valgrind_only_stride" &&
382 expr $test_count "%" $valgrind_only_stride - $valgrind_only_offset = 0 >/dev/null; }
ff09af3f
TR
383 then
384 exec 4>&2 3>&1
385 # Emit a delimiting blank line when going from
386 # non-verbose to verbose. Within verbose mode the
387 # delimiter is printed by test_expect_*. The choice
388 # of the initial $last_verbose is such that before
389 # test 1, we do not print it.
390 test -z "$last_verbose" && echo >&3 ""
391 verbose=t
392 else
393 exec 4>/dev/null 3>/dev/null
394 verbose=
395 fi
396 last_verbose=$verbose
397}
398
5dfc368f
TR
399maybe_teardown_valgrind () {
400 test -z "$GIT_VALGRIND" && return
401 GIT_VALGRIND_ENABLED=
402}
403
404maybe_setup_valgrind () {
405 test -z "$GIT_VALGRIND" && return
ad0e6233 406 if test -z "$valgrind_only" && test -z "$valgrind_only_stride"
5dfc368f
TR
407 then
408 GIT_VALGRIND_ENABLED=t
409 return
410 fi
411 GIT_VALGRIND_ENABLED=
412 if match_pattern_list $test_count $valgrind_only
ad0e6233
TR
413 then
414 GIT_VALGRIND_ENABLED=t
415 elif test -n "$valgrind_only_stride" &&
416 expr $test_count "%" $valgrind_only_stride - $valgrind_only_offset = 0 >/dev/null
5dfc368f
TR
417 then
418 GIT_VALGRIND_ENABLED=t
419 fi
420}
421
a7c58f28
JN
422test_eval_ () {
423 # This is a separate function because some tests use
424 # "return" to end a test_expect_success block early.
781f76b1 425 eval </dev/null >&3 2>&4 "$*"
a7c58f28
JN
426}
427
4d9d62fa 428test_run_ () {
b6b0afdc 429 test_cleanup=:
b586744a 430 expecting_failure=$2
a57397b0 431 setup_malloc_check
a7c58f28 432 test_eval_ "$1"
b6b0afdc 433 eval_ret=$?
a57397b0 434 teardown_malloc_check
b586744a
JH
435
436 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
437 then
1b3185fc 438 setup_malloc_check
a7c58f28 439 test_eval_ "$test_cleanup"
1b3185fc 440 teardown_malloc_check
b586744a 441 fi
1c0cc756
RJ
442 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
443 then
57e1538a
ÆAB
444 echo ""
445 fi
aa0bcf96 446 return "$eval_ret"
4d9d62fa
PR
447}
448
ae75342c 449test_start_ () {
8586f98b 450 test_count=$(($test_count+1))
ff09af3f 451 maybe_setup_verbose
5dfc368f 452 maybe_setup_valgrind
ae75342c
TR
453}
454
455test_finish_ () {
456 echo >&3 ""
5dfc368f 457 maybe_teardown_valgrind
ff09af3f 458 maybe_teardown_verbose
ae75342c
TR
459}
460
461test_skip () {
04ece593 462 to_skip=
e6a6ddc9
TR
463 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
464 then
465 to_skip=t
466 fi
05236a5e
JN
467 if test -z "$to_skip" && test -n "$test_prereq" &&
468 ! test_have_prereq "$test_prereq"
a7bb3940
JS
469 then
470 to_skip=t
471 fi
04ece593
JH
472 case "$to_skip" in
473 t)
07431fc8 474 of_prereq=
05236a5e 475 if test "$missing_prereq" != "$test_prereq"
07431fc8 476 then
05236a5e 477 of_prereq=" of $test_prereq"
07431fc8
JN
478 fi
479
e939e15d
TR
480 say_color skip >&3 "${statusprefix}skipping test: $@"
481 say_color skip "${statusprefix}ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
482 : true
483 ;;
484 *)
485 false
486 ;;
487 esac
488}
489
342e9ef2
TR
490# stub; perf-lib overrides it
491test_at_end_hook_ () {
492 :
493}
494
e1970ce4 495test_done () {
6e7b5aaf 496 GIT_EXIT_OK=t
2d84e9fb 497
517cd55f
TR
498 # Note: t0000 relies on $HARNESS_ACTIVE disabling the .counts
499 # output file
1c0cc756
RJ
500 if test -z "$HARNESS_ACTIVE"
501 then
342e9ef2 502 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 503 mkdir -p "$test_results_dir"
dd78478f
FC
504 base=${0##*/}
505 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
8ef1abe5 506
c54e6be7
ML
507 cat >>"$test_results_path" <<-EOF
508 total $test_count
509 success $test_success
510 fixed $test_fixed
511 broken $test_broken
512 failed $test_failure
513
514 EOF
8ef1abe5 515 fi
41ac414e
JH
516
517 if test "$test_fixed" != 0
518 then
e939e15d 519 say_color error "${statusprefix}# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
520 fi
521 if test "$test_broken" != 0
522 then
e939e15d 523 say_color warn "${statusprefix}# still have $test_broken known breakage(s)"
b73d9a23
AS
524 fi
525 if test "$test_broken" != 0 || test "$test_fixed" != 0
526 then
527 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
528 msg="remaining $test_remaining test(s)"
11d54b8b 529 else
b73d9a23 530 test_remaining=$test_count
11d54b8b 531 msg="$test_count test(s)"
41ac414e 532 fi
e1970ce4 533 case "$test_failure" in
10b94e28 534 0)
5099b99d 535 # Maybe print SKIP message
bf4b7219
RJ
536 if test -n "$skip_all" && test $test_count -gt 0
537 then
538 error "Can't use skip_all after running some tests"
539 fi
5099b99d
ÆAB
540 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
541
1c0cc756
RJ
542 if test $test_external_has_tap -eq 0
543 then
b73d9a23 544 if test $test_remaining -gt 0
d87bd7c1 545 then
e939e15d 546 say_color pass "${statusprefix}# passed all $msg"
d87bd7c1 547 fi
e939e15d 548 say "${statusprefix}1..$test_count$skip_all"
d998bd4a 549 fi
abc5d372
JS
550
551 test -d "$remove_trash" &&
552 cd "$(dirname "$remove_trash")" &&
553 rm -rf "$(basename "$remove_trash")"
554
342e9ef2
TR
555 test_at_end_hook_
556
e1970ce4
JH
557 exit 0 ;;
558
559 *)
1c0cc756
RJ
560 if test $test_external_has_tap -eq 0
561 then
e939e15d
TR
562 say_color error "${statusprefix}# failed $test_failure among $msg"
563 say "${statusprefix}1..$test_count"
d998bd4a 564 fi
5099b99d 565
e1970ce4
JH
566 exit 1 ;;
567
568 esac
569}
570
ad0e6233
TR
571
572# Set up a directory that we can put in PATH which redirects all git
573# calls to 'valgrind git ...'.
e4597aae 574if test -n "$valgrind"
4e1be63c 575then
4e1be63c
JS
576 make_symlink () {
577 test -h "$2" &&
578 test "$1" = "$(readlink "$2")" || {
579 # be super paranoid
580 if mkdir "$2".lock
581 then
582 rm -f "$2" &&
583 ln -s "$1" "$2" &&
584 rm -r "$2".lock
585 else
586 while test -d "$2".lock
587 do
588 say "Waiting for lock on $2."
589 sleep 1
590 done
591 fi
592 }
593 }
594
595 make_valgrind_symlink () {
36bfb0e5
JK
596 # handle only executables, unless they are shell libraries that
597 # need to be in the exec-path. We will just use "#!" as a
598 # guess for a shell-script, since we have no idea what the user
599 # may have configured as the shell path.
600 test -x "$1" ||
601 test "#!" = "$(head -c 2 <"$1")" ||
602 return;
4e1be63c
JS
603
604 base=$(basename "$1")
6cec5c68 605 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
606 # do not override scripts
607 if test -x "$symlink_target" &&
608 test ! -d "$symlink_target" &&
609 test "#!" != "$(head -c 2 < "$symlink_target")"
610 then
611 symlink_target=../valgrind.sh
612 fi
efd92ffd
JS
613 case "$base" in
614 *.sh|*.perl)
615 symlink_target=../unprocessed-script
616 esac
4e1be63c
JS
617 # create the link, or replace it if it is out of date
618 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
619 }
620
ad0e6233
TR
621 # In the case of --valgrind-parallel, we only need to do the
622 # wrapping once, in the main script. The worker children all
623 # have $valgrind_only_stride set, so we can skip based on that.
624 if test -z "$valgrind_only_stride"
625 then
626 # override all git executables in TEST_DIRECTORY/..
627 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
628 mkdir -p "$GIT_VALGRIND"/bin
629 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
efd92ffd 630 do
ad0e6233 631 make_valgrind_symlink $file
efd92ffd 632 done
ad0e6233
TR
633 # special-case the mergetools loadables
634 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
635 OLDIFS=$IFS
636 IFS=:
637 for path in $PATH
638 do
639 ls "$path"/git-* 2> /dev/null |
640 while read file
641 do
642 make_valgrind_symlink "$file"
643 done
644 done
645 IFS=$OLDIFS
646 fi
4e1be63c
JS
647 PATH=$GIT_VALGRIND/bin:$PATH
648 GIT_EXEC_PATH=$GIT_VALGRIND/bin
649 export GIT_VALGRIND
952af351
TR
650 GIT_VALGRIND_MODE="$valgrind"
651 export GIT_VALGRIND_MODE
5dfc368f 652 GIT_VALGRIND_ENABLED=t
ad0e6233
TR
653 if test -n "$valgrind_only" || test -n "$valgrind_only_stride"
654 then
655 GIT_VALGRIND_ENABLED=
656 fi
5dfc368f 657 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
658elif test -n "$GIT_TEST_INSTALLED"
659then
e4597aae
MO
660 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
661 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 662 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
663 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
664else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 665 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
666 if ! test -x "$git_bin_dir/git"
667 then
668 if test -z "$with_dashes"
669 then
e4597aae
MO
670 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
671 fi
672 with_dashes=t
673 fi
674 PATH="$git_bin_dir:$PATH"
6cec5c68 675 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
676 if test -n "$with_dashes"
677 then
6cec5c68 678 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 679 fi
4e1be63c 680fi
6cec5c68 681GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 682unset GIT_CONFIG
8bfa6bd6 683GIT_CONFIG_NOSYSTEM=1
3c995beb 684GIT_ATTR_NOSYSTEM=1
8f323c00 685export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 686
5e87eae9
JH
687if test -z "$GIT_TEST_CMP"
688then
689 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
690 then
691 GIT_TEST_CMP="$DIFF -c"
692 else
693 GIT_TEST_CMP="$DIFF -u"
694 fi
695fi
696
6cec5c68 697GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 698export GITPERLLIB
6cec5c68 699test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
700 error "You haven't built things yet, have you?"
701}
e1970ce4 702
ac10a857 703if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 704then
6cec5c68 705 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 706 export GITPYTHONLIB
6cec5c68 707 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
708 error "You haven't built git_remote_helpers yet, have you?"
709 }
710fi
711
1c0cc756
RJ
712if ! test -x "$GIT_BUILD_DIR"/test-chmtime
713then
56cf9806
EW
714 echo >&2 'You need to build test-chmtime:'
715 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
716 exit 1
717fi
718
e1970ce4 719# Test repository
002d4ce8
JK
720TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
721test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
722case "$TRASH_DIRECTORY" in
723/*) ;; # absolute path is good
724 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 725esac
91c8b825 726test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 727rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 728 GIT_EXIT_OK=t
8d14ac94
JH
729 echo >&5 "FATAL: Cannot prepare test area"
730 exit 1
731}
732
90cff968
AR
733HOME="$TRASH_DIRECTORY"
734export HOME
735
1c0cc756
RJ
736if test -z "$TEST_NO_CREATE_REPO"
737then
38b074de 738 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 739else
38b074de 740 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 741fi
ad0e6233
TR
742
743# Gross hack to spawn N sub-instances of the tests in parallel, and
744# summarize the results. Note that if this is enabled, the script
745# terminates at the end of this 'if' block.
746if test -n "$valgrind_parallel"
747then
748 for i in $(test_seq 1 $valgrind_parallel)
749 do
750 root="$TRASH_DIRECTORY/vgparallel-$i"
751 mkdir "$root"
752 TEST_OUTPUT_DIRECTORY="$root" \
753 ${SHELL_PATH} "$0" \
754 --root="$root" --statusprefix="[$i] " \
755 --valgrind="$valgrind" \
756 --valgrind-only-stride="$valgrind_parallel" \
757 --valgrind-only-offset="$i" &
758 pids="$pids $!"
759 done
760 trap "kill $pids" INT TERM HUP
761 wait $pids
762 trap - INT TERM HUP
763 for i in $(test_seq 1 $valgrind_parallel)
764 do
765 root="$TRASH_DIRECTORY/vgparallel-$i"
766 eval "$(cat "$root/test-results/$(basename "$0" .sh)"-*.counts |
767 sed 's/^\([a-z][a-z]*\) \([0-9][0-9]*\)/inner_\1=\2/')"
768 test_count=$(expr $test_count + $inner_total)
769 test_success=$(expr $test_success + $inner_success)
770 test_fixed=$(expr $test_fixed + $inner_fixed)
771 test_broken=$(expr $test_broken + $inner_broken)
772 test_failure=$(expr $test_failure + $inner_failed)
773 done
774 test_done
775fi
776
1bd9c648
LW
777# Use -P to resolve symlinks in our working directory so that the cwd
778# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 779cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 780
d5d9de1b
JS
781this_test=${0##*/}
782this_test=${this_test%%-*}
e6a6ddc9
TR
783if match_pattern_list "$this_test" $GIT_SKIP_TESTS
784then
785 say_color info >&3 "skipping test $this_test altogether"
786 skip_all="skip all tests in $this_test"
787 test_done
788fi
f17e9fbb 789
8648732e
BC
790# Provide an implementation of the 'yes' utility
791yes () {
792 if test $# = 0
793 then
794 y=y
795 else
796 y="$*"
797 fi
798
799 while echo "$y"
800 do
801 :
802 done
803}
804
f17e9fbb
JS
805# Fix some commands on Windows
806case $(uname -s) in
807*MINGW*)
808 # Windows has its own (incompatible) sort and find
809 sort () {
810 /usr/bin/sort "$@"
811 }
812 find () {
813 /usr/bin/find "$@"
814 }
5397ea31
JS
815 sum () {
816 md5sum "$@"
817 }
4114156a
JS
818 # git sees Windows-style pwd
819 pwd () {
820 builtin pwd -W
821 }
ee9fb68c 822 # no POSIX permissions
6fd1106a 823 # backslashes in pathspec are converted to '/'
fb9a2bea 824 # exec does not inherit the PID
a94114ad 825 test_set_prereq MINGW
cfa96496 826 test_set_prereq NOT_CYGWIN
a31d0665 827 test_set_prereq SED_STRIPS_CR
97669eed 828 test_set_prereq GREP_STRIPS_CR
a31d0665
RJ
829 ;;
830*CYGWIN*)
831 test_set_prereq POSIXPERM
a31d0665
RJ
832 test_set_prereq EXECKEEPSPID
833 test_set_prereq NOT_MINGW
cfa96496 834 test_set_prereq CYGWIN
a31d0665 835 test_set_prereq SED_STRIPS_CR
97669eed 836 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
837 ;;
838*)
839 test_set_prereq POSIXPERM
6fd1106a 840 test_set_prereq BSLASHPSPEC
fb9a2bea 841 test_set_prereq EXECKEEPSPID
3ba9ba8f 842 test_set_prereq NOT_MINGW
cfa96496 843 test_set_prereq NOT_CYGWIN
f17e9fbb
JS
844 ;;
845esac
704a3143 846
b082687c 847( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 848test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 849test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 850test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 851test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 852
bb946bba 853# Can we rely on git's output in the C locale?
30955229
JN
854if test -n "$GETTEXT_POISON"
855then
856 GIT_GETTEXT_POISON=YesPlease
857 export GIT_GETTEXT_POISON
5e9637c6 858 test_set_prereq GETTEXT_POISON
30955229
JN
859else
860 test_set_prereq C_LOCALE_OUTPUT
861fi
bb946bba 862
cabdee2c
JH
863# Use this instead of test_cmp to compare files that contain expected and
864# actual output from git commands that can be translated. When running
865# under GETTEXT_POISON this pretends that the command produced expected
866# results.
867test_i18ncmp () {
868 test -n "$GETTEXT_POISON" || test_cmp "$@"
869}
870
127df8c6
JH
871# Use this instead of "grep expected-string actual" to see if the
872# output from a git command that can be translated either contains an
873# expected string, or does not contain an unwanted one. When running
874# under GETTEXT_POISON this pretends that the command produced expected
875# results.
876test_i18ngrep () {
877 if test -n "$GETTEXT_POISON"
878 then
879 : # pretend success
880 elif test "x!" = "x$1"
881 then
882 shift
883 ! grep "$@"
884 else
885 grep "$@"
886 fi
887}
888
20073274
AS
889test_lazy_prereq PIPE '
890 # test whether the filesystem supports FIFOs
9443605b
ML
891 case $(uname -s) in
892 CYGWIN*)
893 false
894 ;;
895 *)
896 rm -f testfifo && mkfifo testfifo
897 ;;
898 esac
20073274
AS
899'
900
04083f27
JH
901test_lazy_prereq SYMLINKS '
902 # test whether the filesystem supports symbolic links
903 ln -s x y && test -h y
904'
c91cfd19 905
ac39aa61
MG
906test_lazy_prereq CASE_INSENSITIVE_FS '
907 echo good >CamelCase &&
908 echo bad >camelcase &&
909 test "$(cat CamelCase)" != good
910'
911
5b0b5dd4
MG
912test_lazy_prereq UTF8_NFD_TO_NFC '
913 # check whether FS converts nfd unicode to nfc
914 auml=$(printf "\303\244")
915 aumlcdiar=$(printf "\141\314\210")
916 >"$auml" &&
917 case "$(echo *)" in
918 "$aumlcdiar")
919 true ;;
920 *)
921 false ;;
922 esac
923'
924
09feffb6
JK
925test_lazy_prereq AUTOIDENT '
926 sane_unset GIT_AUTHOR_NAME &&
927 sane_unset GIT_AUTHOR_EMAIL &&
928 git var GIT_AUTHOR_IDENT
929'
930
c91cfd19
ÆAB
931# When the tests are run as root, permission tests will report that
932# things are writable when they shouldn't be.
933test -w / || test_set_prereq SANITY
f838ce58
JK
934
935GIT_UNZIP=${GIT_UNZIP:-unzip}
936test_lazy_prereq UNZIP '
937 "$GIT_UNZIP" -v
938 test $? -ne 127
939'